import { StringLoader } from "./stringLoader";
export class MultiLoader extends StringLoader {
    constructor(loaders) {
        super();
        this.loaders = loaders;
    }
    getData() {
        let data = [];
        for (const loaderOption of this.loaders)
            data = data.concat(loaderOption.loader.getData());
        return data;
    }
    getRefIndex(index) {
        let ldIndex = 0;
        let ldC = 0;
        for (const loaderOption of this.loaders) {
            ldIndex += 1;
            ldC += loaderOption.loader.length;
            if (ldC > index) {
                ldIndex -= 1;
                ldC -= loaderOption.loader.length;
            }
        }
        return `${this.loaders[ldIndex]?.label} #${index - ldC + 1}`;
    }
}
