import { trim } from "../utils/string";
import { StringLoader } from "../data";
export class Response {
    constructor(Options) {
        const { trigger, response } = Options;
        this.trigger = trigger;
        this.response = response;
    }
    setClient(client) {
        this.client = client;
    }
    get triggered() {
        return this.triggeredKeyword;
    }
    get lastReturned() {
        return this.returnedItem;
    }
    isTrigger(message) {
        const { prefixes = [], mention = false, keywords, keywords_exact_check = false, } = this.trigger;
        if (mention && !message.includes(this.client?.user?.id ?? ""))
            return false;
        if (prefixes.length &&
            !(() => {
                for (const prefix of prefixes)
                    if (message.startsWith(prefix))
                        return true;
                return false;
            })())
            return false;
        const keyword_check = keywords_exact_check
            ? (msg, kw) => msg.includes(kw)
            : (msg, kw) => trim(msg).includes(trim(kw));
        let data = [];
        if (keywords instanceof StringLoader) {
            data = keywords.getData();
        }
        else {
            data = keywords;
        }
        for (const keyword of data)
            if (keyword_check(message, keyword)) {
                this.triggeredKeyword = keyword;
                return true;
            }
        return false;
    }
    getReply() {
        const data = this.response.loader.getData();
        const selectedIndex = Math.floor(this.response.loader.getData().length * Math.random());
        let selectedData = data[selectedIndex];
        let refIndex = this.response.loader.getRefIndex(selectedIndex);
        this.returnedItem = {
            refIndex,
            data: selectedData,
        };
        return {
            message: selectedData,
            react: this.response.react,
            reply: this.response.reply,
            audio: this.response.audio,
            refIndex,
        };
    }
}
